Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Interface QPaintDeviceInterface

All Superinterfaces:
  QtJambiInterface

All Known Implementing Classes:
  EffectWidget, QAbstractButton, QAbstractItemView, QAbstractPageSetupDialog, QAbstractPrintDialog, QAbstractScrollArea, QAbstractSlider, QAbstractSpinBox, QBitmap, QCalendarWidget, QCheckBox, QColorDialog, QColumnView, QComboBox, QCommandLinkButton, QDateEdit, QDateTimeEdit, QDesktopWidget, QDial, QDialog, QDialogButtonBox, QDockWidget, QDoubleSpinBox, QErrorMessage, QFileDialog, QFocusFrame, QFontComboBox, QFontDialog, QFrame, QGLFramebufferObject, QGLPixelBuffer, QGLWidget, QGraphicsView, QGroupBox, QHeaderView, QImage, QInputDialog, QLabel, QLCDNumber, QLineEdit, QListView, QListWidget, QMainWindow, QMdiArea, QMdiSubWindow, QMenu, QMenuBar, QMessageBox, QPageSetupDialog, QPaintDevice, QPicture, QPixmap, QPlainTextEdit, QPrintDialog, QPrinter, QPrintPreviewDialog, QPrintPreviewWidget, QProgressBar, QProgressDialog, QPushButton, QRadioButton, QRubberBand, QScrollArea, QScrollBar, QSizeGrip, QSlider, QSpinBox, QSplashScreen, QSplitter, QSplitterHandle, QStackedWidget, QStatusBar, QSvgGenerator, QSvgWidget, QTabBar, QTableView, QTableWidget, QTabWidget, QTextBrowser, QTextEdit, QTimeEdit, QToolBar, QToolBox, QToolButton, QTreeView, QTreeWidget, QUndoView, QWebView, QWidget, QWizard, QWizardPage, QWorkspace, SeekSlider, VideoPlayer, VideoWidget, VolumeSlider

    public interface QPaintDeviceInterface

extends QtJambiInterface

The `QPaintDevice` class is the base class of objects that can be painted. A paint device is an abstraction of a two-dimensional space that can be drawn using a `QPainter`. Its default coordinate system has its origin located at the top-left position. X increases to the right and Y increases downwards. The unit is one pixel.

The drawing capabilities of `QPaintDevice` are currently implemented by the `QWidget`, `QImage`, `QPixmap`, QGLPixelBuffer, `QPicture`, and `QPrinter` subclasses.

To implement support for a new backend, you must derive from `QPaintDevice` and reimplement the virtual `paintEngine()` function to tell `QPainter` which paint engine should be used to draw on this particular device. Note that you also must create a corresponding paint engine to be able to draw on the device, i.e derive from `QPaintEngine` and reimplement its virtual functions.

Warning: Qt requires that a QApplication object exists before any paint devices can be created. Paint devices access window system resources, and these resources are not initialized before an application object is created.

The `QPaintDevice` class provides several functions returning the various device metrics: The `depth()` function returns its bit depth (number of bit planes). The `height()` function returns its height in default coordinate system units (e.g. pixels for `QPixmap` and `QWidget`) while `heightMM()` returns the height of the device in millimeters. Similiarily, the `width()` and `widthMM()` functions return the width of the device in default coordinate system units and in millimeters, respectively. Alternatively, the protected `metric()` function can be used to retrieve the metric information by specifying the desired `PaintDeviceMetric` as argument.

The `logicalDpiX()` and `logicalDpiY()` functions return the horizontal and vertical resolution of the device in dots per inch. The `physicalDpiX()` and `physicalDpiY()` functions also return the resolution of the device in dots per inch, but note that if the logical and vertical resolution differ, the corresponding `QPaintEngine` must handle the mapping. Finally, the `numColors()` function returns the number of different colors available for the paint device.

See also:
  `QPaintEngine`, `QPainter`, The Coordinate System, and The Paint System.

Method Summary
`int` | `depth()` Returns the bit depth (number of bit planes) of the paint device.
`int` | `height()` Returns the height of the paint device in default coordinate system units (e.g.
`int` | `heightMM()` Returns the height of the paint device in millimeters.
`int` | `logicalDpiX()` Returns the horizontal resolution of the device in dots per inch, which is used when computing font sizes.
`int` | `logicalDpiY()` Returns the vertical resolution of the device in dots per inch, which is used when computing font sizes.
`int` | `metric(QPaintDevice.PaintDeviceMetric metric)` Returns the metric information for the given paint device `metric`.
`int` | `numColors()` Returns the number of different colors available for the paint device.
`QPaintEngine` | `paintEngine()` Returns a pointer to the paint engine used for drawing on the device.
`boolean` | `paintingActive()` Returns true if the device is currently being painted on, i.e.
`int` | `physicalDpiX()` Returns the horizontal resolution of the device in dots per inch.
`int` | `physicalDpiY()` Returns the horizontal resolution of the device in dots per inch.
`int` | `width()` Returns the width of the paint device in default coordinate system units (e.g.
`int` | `widthMM()` Returns the width of the paint device in millimeters.

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Method Detail

### depth

    int depth()

  Returns the bit depth (number of bit planes) of the paint device.

### height

    int height()

  Returns the height of the paint device in default coordinate system units (e.g. pixels for `QPixmap` and `QWidget`).

See also:
  `heightMM()`.

### heightMM

    int heightMM()

  Returns the height of the paint device in millimeters.

See also:
  `height()`.

### logicalDpiX

    int logicalDpiX()

  Returns the horizontal resolution of the device in dots per inch, which is used when computing font sizes. For X11, this is usually the same as could be computed from `widthMM()`.

  Note that if the `logicalDpiX()` doesn't equal the `physicalDpiX()`, the corresponding `QPaintEngine` must handle the resolution mapping.

See also:
  `logicalDpiY()`, and `physicalDpiX()`.

### logicalDpiY

    int logicalDpiY()

  Returns the vertical resolution of the device in dots per inch, which is used when computing font sizes. For X11, this is usually the same as could be computed from `heightMM()`.

  Note that if the `logicalDpiY()` doesn't equal the `physicalDpiY()`, the corresponding `QPaintEngine` must handle the resolution mapping.

See also:
  `logicalDpiX()`, and `physicalDpiY()`.

### numColors

    int numColors()

  Returns the number of different colors available for the paint device. Since this value is an int, it will not be sufficient to represent the number of colors on 32 bit displays, in this case `INT_MAX` is returned instead.

### paintingActive

    boolean paintingActive()

  Returns true if the device is currently being painted on, i.e. someone has called `QPainter::begin()` but not yet called `QPainter::end()` for this device; otherwise returns false.

See also:
  `QPainter::isActive()`.

### physicalDpiX

    int physicalDpiX()

  Returns the horizontal resolution of the device in dots per inch. For example, when printing, this resolution refers to the physical printer's resolution. The logical DPI on the other hand, refers to the resolution used by the actual paint engine.

  Note that if the `physicalDpiX()` doesn't equal the `logicalDpiX()`, the corresponding `QPaintEngine` must handle the resolution mapping.

See also:
  `physicalDpiY()`, and `logicalDpiX()`.

### physicalDpiY

    int physicalDpiY()

  Returns the horizontal resolution of the device in dots per inch. For example, when printing, this resolution refers to the physical printer's resolution. The logical DPI on the other hand, refers to the resolution used by the actual paint engine.

  Note that if the `physicalDpiY()` doesn't equal the `logicalDpiY()`, the corresponding `QPaintEngine` must handle the resolution mapping.

See also:
  `physicalDpiX()`, and `logicalDpiY()`.

### width

    int width()

  Returns the width of the paint device in default coordinate system units (e.g. pixels for `QPixmap` and `QWidget`).

See also:
  `widthMM()`.

### widthMM

    int widthMM()

  Returns the width of the paint device in millimeters.

See also:
  `width()`.

### metric

    int metric(QPaintDevice.PaintDeviceMetric metric)

  Returns the metric information for the given paint device `metric`.

See also:
  `PaintDeviceMetric` .

### paintEngine

    QPaintEngine paintEngine()

  Returns a pointer to the paint engine used for drawing on the device.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD